<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4">

  <app-breadcrumbs [forceReload]="tenantId"></app-breadcrumbs>

  <div
    id="workflowManagementTitle"
    class="h3" [innerText]="messages.WORKFLOW_MANAGEMENT">
  </div>

  <!-- Header -->

  <div class="mt-3 mb-2 d-flex align-items-start">

    <button
      ls-button
      class="me-2"
      (click)="onCreateWorkflowClicked()"
      [icon]="commonIcons.CREATE_ICON"
      [text]="messages.CREATE_WORKFLOW"
      [disabled]="!tenantId">
    </button>

    <!--    <button ls-button                               -->
    <!--      class="me-2"                           -->
    <!--      (click)="onImportWorkflowClicked()"    -->
    <!--      [icon]="uploadIcon"                    -->
    <!--      [text]="messages.IMPORT_WORKFLOW"     -->
    <!--      [disabled]="!tenantId">                -->
    <!--    </button>                             -->

    <app-search-bar
      class="search-input"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="messages.SEARCH_WORKFLOWS">
    </app-search-bar>

    <span class="flex-grow-1"></span>
    <span class="p-1 px-2" [innerText]="commonMessages.PAGINATION_SIZE_LABEL"></span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="requestWorkflowList(true)">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="workflowManagementTitle"
    class="bg-white table table-striped table-fixed table-borderless border shadow-sm w-100 table-text-overflow">
    <thead class="border">
      <tr>
        <th
          (click)="onRowOrderClicked(sortByEnum.Name)"
          scope="col">
          <fa-icon
            class="{{ sortBy === sortByEnum.Name ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.NAME }}
        </th>
        <th
          (click)="onRowOrderClicked(sortByEnum.Key)"
          scope="col">
          <fa-icon
            class="{{ sortBy === sortByEnum.Key ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.KEY }}
        </th>
        <th
          scope="col"
          class="col-int-fixed-size"
          [innerText]="messages.REVISION">
        </th>
        <th
          *ngIf="userPreferences.showAdminIds"
          scope="col"
          class="col-id-fixed-size"
          (click)="onRowOrderClicked(sortByEnum.Id)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Id ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true"></fa-icon>
          {{ commonMessages.ID }}
        </th>
        <th scope="col" class="col-buttons-fixed-size col-buttons-3-buttons" [innerText]="commonMessages.ACTIONS"></th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let workflowDefinitionRepresentation of workflowDefinitionRepresentationList">
        <td class="overflow-hidden text-overflow-ellipsis">
          <span
            class="sortable-row"
            [innerText]="workflowDefinitionRepresentation.name | namePipe">
          </span>
        </td>
        <td class="overflow-hidden text-overflow-ellipsis">
          <span
            class="sortable-row font-monospace text-size-small"
            [innerText]="workflowDefinitionRepresentation.key">
          </span>
        </td>
        <td [innerText]="workflowDefinitionRepresentation.version | namePipe"></td>
        <td *ngIf="userPreferences.showAdminIds">
          <span
            class="sortable-row font-monospace text-size-small"
            [innerText]="prettyPrintId(workflowDefinitionRepresentation.id)">
          </span>
        </td>
        <td>
          <button
            type="button"
            class="btn btn-sm btn-outline-primary"
            [title]="commonMessages.EDIT"
            (click)="onEditButtonClicked(workflowDefinitionRepresentation)">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>
          <button
            type="button"
            class="btn btn-sm btn-outline-primary ms-2"
            [title]="messages.CLONE_WORKFLOW"
            (click)="onCloneButtonClicked(workflowDefinitionRepresentation)">
            <fa-icon [icon]="copyIcon"></fa-icon>
          </button>
          <button
            type="button"
            class="btn btn-sm btn-outline-danger ms-2"
            [title]="commonMessages.DELETE"
            (click)="onDeleteButtonClicked(workflowDefinitionRepresentation)">
            <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="workflowDefinitionRepresentationList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_WORKFLOW_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="requestWorkflowList(false)">
  </ngb-pagination>

</div>
